package peermgr

import (
	"github.com/libp2p/go-libp2p-core/peer"
	"github.com/link33/sidecar/internal/port"
	"github.com/link33/sidecar/model/pb"
	"github.com/meshplus/bitxhub-kit/crypto"
)

type local struct {
	id      peer.ID
	privKey crypto.PrivateKey
	tag     string
	rev     chan *pb.IBTPX
}

func (l *local) ID() string {
	return l.id.String()
}

func (l *local) Type() string {
	return port.Sidecar
}

func (l *local) Name() string {
	return l.ID()
}

func (l *local) Tag() string {
	return l.tag
}

func (l *local) Send(msg port.Message) (*pb.Message, error) {
	panic("implement me")
}

func (l *local) AsyncSend(msg port.Message) error {
	panic("implement me")
}

func (l *local) ListenIBTPX() <-chan *pb.IBTPX {
	return l.rev
}
